// 7-zip32.cpp : DLL AvP[Vp̃Gg |Cg`܂B
//
#include "stdafx.h"
#include "DialogProc.h"
#include "OpenArchive.h"
#include "MainFunc.h"
#include "SplitCmdLine.h"
#include "resource.h"

HINSTANCE g_hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		g_hInstance = (HINSTANCE)hModule;
		break;
	case DLL_PROCESS_DETACH:
		COpenArchive::RemoveAll();
		break;
	}
    return TRUE;
}

int WINAPI SevenZip(const HWND _hwnd, LPCSTR _szCmdLine, LPSTR _szOutput, const DWORD _dwSize)
{
	if (g_StdOut.m_hThread)
		return ERROR_ALREADY_RUNNING;
	char lpCurrentDirectory[MAX_PATH];
	CSplitCmdLine scl;
	if (!scl.Split(_szCmdLine))
		return ERROR_COMMAND_NAME;
	if (scl.m_lpBaseDirectory)
	{
		::GetCurrentDirectory(MAX_PATH, lpCurrentDirectory);
		::SetCurrentDirectory(scl.m_lpBaseDirectory);
	}

	g_StdOut.m_hThread = ::CreateThread(NULL, 0, Main, (void*)&scl, CREATE_SUSPENDED, &g_StdOut.m_dwThreadID);

	LPARAM lParam;
	if (scl.m_bHide)
	{
		g_StdOut.m_bHide = TRUE;
		lParam = 0;
    }
	else
		lParam = (LPARAM)scl.m_argv[1][0];

	::CreateDialogParam(g_hInstance, MAKEINTRESOURCE(IDD_PROGRESS), _hwnd, ProgressDialogProc, lParam);

	MSG msg;
	while (::GetMessage(&msg, NULL, 0, 0))
	{
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);

		if (msg.hwnd == _hwnd && msg.message == 0)
			g_StdOut.StopProgress();
	}

	::WaitForSingleObject(g_StdOut.m_hThread, INFINITE);
	DWORD dwThreadId;
	::GetExitCodeThread(g_StdOut.m_hThread, &dwThreadId);
	::CloseHandle(g_StdOut.m_hThread);
	g_StdOut.CopyBuf(_szOutput, _dwSize);
	g_StdOut.ReSet();
	if (scl.m_lpBaseDirectory)
		::SetCurrentDirectory(lpCurrentDirectory);
    return dwThreadId;
}

WORD WINAPI SevenZipGetVersion()
{
	return (SEVENZIP32_VERSION / 10000);
}

// {IɈӖȂ
static BOOL bCursorMode = FALSE;
static BOOL bBackGroundMode = FALSE;
static int  nCursorInterval = 80;
BOOL WINAPI SevenZipGetCursorMode() { return bCursorMode; }
BOOL WINAPI SevenZipSetCursorMode(const BOOL _CursorMode) { bCursorMode = _CursorMode; return TRUE; }
BOOL WINAPI SevenZipGetBackGroundMode() { return bBackGroundMode; }
BOOL WINAPI SevenZipSetBackGroundMode(const BOOL _BackGroundMode) { bBackGroundMode = _BackGroundMode; return TRUE; }
WORD WINAPI SevenZipGetCursorInterval() { return nCursorInterval; }
BOOL WINAPI SevenZipSetCursorInterval(const WORD _Interval) { nCursorInterval = _Interval; return TRUE; }

BOOL WINAPI SevenZipGetRunning()
{
	return (g_StdOut.m_hThread != NULL);
}

// Ăяo
BOOL WINAPI SevenZipConfigDialog(const HWND _hwnd, LPSTR _szOptionBuffer, const int _iMode)
{
	if (g_StdOut.m_hThread)
		return ERROR_ALREADY_RUNNING;
	return DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_CONFIG), _hwnd, ConfigDialogProc);
}

// _iMode͖
BOOL WINAPI SevenZipCheckArchive(LPCSTR _szFileName, const int _iMode)
{
	if (SevenZipGetRunning())
		return FALSE;
	return (CheckArchive(_szFileName, NULL) == S_OK);
}

int WINAPI SevenZipGetFileCount(LPCSTR _szArcFile)
{
	HARC hArc = SevenZipOpenArchive(NULL, _szArcFile, 0);
	COpenArchive* pOpenArchive = COpenArchive::FindObject(hArc);
	if (pOpenArchive == NULL)
		return -1;
	int nCount = pOpenArchive->GetFileCount();
	SevenZipCloseArchive(hArc);
	return nCount;
}

BOOL WINAPI SevenZipQueryFunctionList(const int _iFunction)
{
	switch (_iFunction)
	{
	case ISARC:
	case ISARC_GET_VERSION:
	case ISARC_GET_CURSOR_INTERVAL:
	case ISARC_SET_CURSOR_INTERVAL:
	case ISARC_GET_BACK_GROUND_MODE:
	case ISARC_SET_BACK_GROUND_MODE:
	case ISARC_GET_CURSOR_MODE:
	case ISARC_SET_CURSOR_MODE:
	case ISARC_GET_RUNNING:
		
	case ISARC_CHECK_ARCHIVE:
	case ISARC_CONFIG_DIALOG:
	case ISARC_GET_FILE_COUNT:
	case ISARC_QUERY_FUNCTION_LIST:
//	case ISARC_HOUT:
//	case ISARC_STRUCTOUT:
//	case ISARC_GET_ARC_FILE_INFO:
		
	case ISARC_OPEN_ARCHIVE:
	case ISARC_CLOSE_ARCHIVE:
	case ISARC_FIND_FIRST:
	case ISARC_FIND_NEXT:
//	case ISARC_EXTRACT:
//	case ISARC_ADD:
//	case ISARC_MOVE:
//	case ISARC_DELETE:
	case ISARC_SETOWNERWINDOW:
	case ISARC_CLEAROWNERWINDOW:
	case ISARC_SETOWNERWINDOWEX:
	case ISARC_KILLOWNERWINDOWEX:
		
	case ISARC_GET_ARC_FILE_NAME:
	case ISARC_GET_ARC_FILE_SIZE:
	case ISARC_GET_ARC_ORIGINAL_SIZE:
	case ISARC_GET_ARC_COMPRESSED_SIZE:
	case ISARC_GET_ARC_RATIO:
	case ISARC_GET_ARC_DATE:
	case ISARC_GET_ARC_TIME:
//	case ISARC_GET_ARC_OS_TYPE:
//	case ISARC_GET_ARC_IS_SFX_FILE:
	case ISARC_GET_ARC_WRITE_TIME_EX:
	case ISARC_GET_ARC_CREATE_TIME_EX:
	case ISARC_GET_ARC_ACCESS_TIME_EX:
//	case ISARC_GET_ARC_CREATE_TIME_EX2:
//	case ISARC_GET_ARC_WRITE_TIME_EX2:
	case ISARC_GET_FILE_NAME:
	case ISARC_GET_ORIGINAL_SIZE:
	case ISARC_GET_COMPRESSED_SIZE:
	case ISARC_GET_RATIO:
	case ISARC_GET_DATE:
	case ISARC_GET_TIME:
	case ISARC_GET_CRC:
	case ISARC_GET_ATTRIBUTE:
//	case ISARC_GET_OS_TYPE:
	case ISARC_GET_METHOD:
	case ISARC_GET_WRITE_TIME:
//	case ISARC_GET_CREATE_TIME:
//	case ISARC_GET_ACCESS_TIME:
	case ISARC_GET_WRITE_TIME_EX:
//	case ISARC_GET_CREATE_TIME_EX:
//	case ISARC_GET_ACCESS_TIME_EX:
//	case ISARC_SET_ENUM_MEMBERS_PROC:
//	case ISARC_CLEAR_ENUM_MEMBERS_PROC:
	case ISARC_GET_ARC_FILE_SIZE_EX:
	case ISARC_GET_ARC_ORIGINAL_SIZE_EX:
	case ISARC_GET_ARC_COMPRESSED_SIZE_EX:
	case ISARC_GET_ORIGINAL_SIZE_EX:
	case ISARC_GET_COMPRESSED_SIZE_EX:
//	case ISARC_SETOWNERWINDOWEX64:
//	case ISARC_KILLOWNERWINDOWEX64:
//	case ISARC_SET_ENUM_MEMBERS_PROC64:
//	case ISARC_CLEAR_ENUM_MEMBERS_PROC64:
//	case ISARC_OPEN_ARCHIVE2:
//	case ISARC_GET_ARC_READ_SIZE:
//	case ISARC_GET_ARC_READ_SIZE_EX:
		return TRUE;
	default:
		break;
	}
	return FALSE;
}

// Ƃ肠_dwMode͕ۑĂ邯ǈӖ
HARC WINAPI SevenZipOpenArchive(const HWND _hwnd, LPCSTR _szFileName, const DWORD _dwMode)
{
	COpenArchive* pOpenArchive = new COpenArchive;
	if (pOpenArchive)
	{
		if (pOpenArchive->Open(_szFileName, _dwMode) == FALSE)
		{
			delete pOpenArchive;
			return NULL;
		}
	}
	return (HARC)pOpenArchive;
}

int WINAPI SevenZipCloseArchive(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	delete pOpenArchive;
	return 0;
}

int WINAPI SevenZipFindFirst(HARC _harc, LPCSTR _szWildName, INDIVIDUALINFO *_lpSubInfo)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return ERROR_HARC_ISNOT_OPENED;
	return pOpenArchive->FindFirst(_szWildName, _lpSubInfo);
}

int WINAPI SevenZipFindNext(HARC _harc, INDIVIDUALINFO *_lpSubInfo)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return ERROR_NOT_SEARCH_MODE;
	return pOpenArchive->FindNext(_lpSubInfo);
}

int WINAPI SevenZipGetArcFileName(HARC _harc, LPSTR _lpBuffer, const int _nSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return ERROR_HARC_ISNOT_OPENED;
	return pOpenArchive->GetArcFileName(_lpBuffer, _nSize);
}

DWORD WINAPI SevenZipGetArcFileSize(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcFileSize();
}

DWORD WINAPI SevenZipGetArcOriginalSize(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcOriginalSize();
}

DWORD WINAPI SevenZipGetArcCompressedSize(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcCompressedSize();
}

WORD WINAPI SevenZipGetArcRatio(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcRatio();
}

WORD WINAPI SevenZipGetArcDate(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcDate();
}

WORD WINAPI SevenZipGetArcTime(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcTime();
}

// Gĝ݁BG[ȊOAK0Ԃ
UINT WINAPI SevenZipGetArcOSType(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcOSType();
}

// Gĝ݁BG[ȊOAK0Ԃ
int WINAPI SevenZipIsSFXFile(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->IsSFXFile();
}

int WINAPI SevenZipGetFileName(HARC _harc, LPSTR _lpBuffer, const int _nSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return ERROR_HARC_ISNOT_OPENED;
	return pOpenArchive->GetFileName(_lpBuffer, _nSize);
}

DWORD WINAPI SevenZipGetOriginalSize(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetOriginalSize();
}

DWORD WINAPI SevenZipGetCompressedSize(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetCompressedSize();
}

WORD WINAPI SevenZipGetRatio(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetRatio();
}

WORD WINAPI SevenZipGetDate(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetDate();
}

WORD WINAPI SevenZipGetTime(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetTime();
}

DWORD WINAPI SevenZipGetCRC(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetCRC();
}

int WINAPI SevenZipGetAttribute(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetAttribute();
}

// Gĝ݁BG[ȊOAK0Ԃ
UINT WINAPI SevenZipGetOSType(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetOSType();
}

int WINAPI SevenZipGetMethod(HARC _harc, LPSTR _lpBuffer, const int _nSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return ERROR_HARC_ISNOT_OPENED;
	return pOpenArchive->GetMethod(_lpBuffer, _nSize);
}

DWORD WINAPI SevenZipGetWriteTime(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetWriteTime();
}
/*
DWORD WINAPI SevenZipGetCreateTime(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetCreateTime();
}

DWORD WINAPI SevenZipGetAccessTime(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetAccessTime();
}
*/
BOOL WINAPI SevenZipGetWriteTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetWriteTimeEx(_lpftLastWriteTime);
}
/*
BOOL WINAPI SevenZipGetCreateTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetCreateTimeEx(_lpftLastWriteTime);
}

BOOL WINAPI SevenZipGetAccessTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetAccessTimeEx(_lpftLastWriteTime);
}
*/
BOOL WINAPI SevenZipGetArcCreateTimeEx(HARC _harc, FILETIME *_lpftCreationTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcCreateTimeEx(_lpftCreationTime);
}

BOOL WINAPI SevenZipGetArcAccessTimeEx(HARC _harc, FILETIME *_lpftLastAccessTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcAccessTimeEx(_lpftLastAccessTime);
}

BOOL WINAPI SevenZipGetArcWriteTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcWriteTimeEx(_lpftLastWriteTime);
}

BOOL WINAPI SevenZipGetArcFileSizeEx(HARC _harc, ULHA_INT64 *_lpllSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcFileSizeEx(_lpllSize);
}

BOOL WINAPI SevenZipGetArcOriginalSizeEx(HARC _harc, ULHA_INT64 *_lpllSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcOriginalSizeEx(_lpllSize);
}

BOOL WINAPI SevenZipGetArcCompressedSizeEx(HARC _harc, ULHA_INT64 *_lpllSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcCompressedSizeEx(_lpllSize);
}

BOOL WINAPI SevenZipGetOriginalSizeEx(HARC _harc, ULHA_INT64 *_lpllSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetOriginalSizeEx(_lpllSize);
}

BOOL  WINAPI SevenZipGetCompressedSizeEx(HARC _harc, ULHA_INT64 *_lpllSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetCompressedSizeEx(_lpllSize);
}

// bZ[W𑗂邯ǒg͋ہB
BOOL WINAPI SevenZipSetOwnerWindow(HWND _hwnd)
{
	return g_StdOut.SetOwnerWindow(_hwnd);
}

BOOL WINAPI SevenZipClearOwnerWindow()
{
	return g_StdOut.ClearOwnerWindow();
}

// ֐ɏnǒg͋ہB
BOOL WINAPI SevenZipSetOwnerWindowEx(HWND _hwnd, LPARCHIVERPROC _lpArcProc)
{
	return g_StdOut.SetOwnerWindowEx(_hwnd, _lpArcProc);
}

BOOL WINAPI SevenZipKillOwnerWindowEx(HWND _hwnd)
{
	if (_hwnd && _hwnd != g_StdOut.GetOwnerWindow())
		return FALSE;
	return g_StdOut.ClearOwnerWindow();
}

WORD WINAPI SevenZipGetSubVersion()
{
	return (SEVENZIP32_VERSION % 10000);
}

int WINAPI SevenZipGetArchiveType(LPCSTR _szFileName)
{
	char lpMode[8];
	if (CheckArchive(_szFileName, lpMode) == E_FAIL)
		return -1;
	if (!_stricmp(lpMode, "zip"))
		return ARCHIVETYPE_ZIP;
	if (!_stricmp(lpMode, "7z"))
		return ARCHIVETYPE_7Z;
	return 0;
}
