#include "stdafx.h"
#include "MainFunc.h"
#include "SplitCmdLine.h"
#include "resource.h"

// #include <locale.h>

#include "Windows/COM.h"
#include "Windows/Error.h"

#include "Common/NewHandler.h"
#include "Common/StringConvert.h"

#include "ConsoleCloseUtils.h"
#include "ArError.h"
#include "../../Common\OpenEngine200.h"
#include "../../Console/OpenCallback.h"

using namespace NWindows;

extern int Main2(int aNumArguments, const char *anArguments[]);

static const char *kExceptionErrorMessage = "\n\nError:\n";
static const char *kUserBreak  = "\nBreak signaled\n";

static const char *kMemoryExceptionMessage = "\n\nMemory Error! Can't allocate!\n";
static const char *kUnknownExceptionMessage = "\n\nUnknown Error\n";
static const char *kInternalExceptionMessage = "\n\nInternal Error #";

extern HINSTANCE g_hInstance;

DWORD WINAPI Main(LPVOID lpParameter)
{
	// ɋN
	if (g_StdOut.IsStop())
		return ERROR_ALREADY_RUNNING;

	// R}hC𕪊ăC֓n
	CSplitCmdLine* pslc = (CSplitCmdLine*)lpParameter;
	int result = SendCommand7zip(pslc->m_argc, (const char**)pslc->m_argv);

	// EBhEŕ
	g_StdOut.StopProgress();
	::PostMessage(g_StdOut.GetOutDialogHandle(), WM_CLOSE, 0, 0);
	return result;
}

int SendCommand7zip(int argc, const char** argv)
{
//	setlocale(LC_COLLATE, ".OCP");
	int result=1;
//	CNewHandlerSetter aNewHandlerSetter;
//	NCOM::CComInitializer aComInitializer;
	try
	{
		NConsoleClose::CCtrlHandlerSetter aCtrlHandlerSetter;
		try
		{
			result = Main2(argc, argv);
		}
		catch(const NConsoleClose::CCtrlBreakException &)
		{
			throw  NExitCode::CSystemError(E_ABORT);
//			g_StdOut << endl << kUserBreak;
//			return(ERROR_USER_CANCEL);
		}
	}
	catch(const CNewException)
	{
		g_StdOut << kMemoryExceptionMessage;
		return(NExitCode::kMemoryError);
	}
	catch(const CSystemException &e)
	{
		g_StdOut << "System Error: " << (UINT64)(e.ErrorCode);
		return (NExitCode::kFatalError);
	}
	catch(NExitCode::EEnum &aExitCode)
	{
		g_StdOut << kInternalExceptionMessage << aExitCode << endl;
		return(aExitCode);
	}
	catch(const NExitCode::CSystemError &aSystemError)
	{
		UINT32 ErrorValue = aSystemError.ErrorValue;
//		if (g_StdOut.IsStop())
//			ErrorValue = E_ABORT;
		CSysString aMessage;
		NError::MyFormatMessage(ErrorValue, aMessage);
		switch(ErrorValue)
		{
		case E_ABORT:
			g_StdOut << endl << endl << SystemStringToOemString(aMessage) << endl;
			return ERROR_USER_CANCEL;
		default:
			g_StdOut << endl << endl << "System error:" << endl << 
				SystemStringToOemString(aMessage) << endl;
			return(NExitCode::kFatalError);
		}
	}
	catch(const NExitCode::CMultipleErrors &aMultipleErrors)
	{
		g_StdOut << endl << aMultipleErrors.NumErrors << " errors" << endl;
		return(ERROR_FILE_CRC);
	}
	catch(const UString &aString)
	{
		g_StdOut << kExceptionErrorMessage << 
			UnicodeStringToMultiByte(aString, CP_OEMCP) << endl;
		return(NExitCode::kFatalError);
	}
	catch(const char *aString)
	{
		g_StdOut << kExceptionErrorMessage << aString << endl;
		return(NExitCode::kFatalError);
	}
	catch(int t)
	{
		g_StdOut << kInternalExceptionMessage << t << endl;
		return(NExitCode::kFatalError);
	}
	catch(...)
	{
		g_StdOut << kUnknownExceptionMessage;
		return(NExitCode::kFatalError);
	}
	if (argc == 1)
		return ERROR_COMMAND_NAME;
	return result;
}

// t@CΉĂ邩`FbNk̎ނ擾
//  S_OK / Ή S_FALSE / ȊÕG[ E_FAIL ԂB
HRESULT CheckArchive(LPCSTR lpFileName, LPSTR lpMode)
{
	NZipRootRegistry::CArchiverInfo anArchiverInfo;
	CComObjectNoLock<COpenCallbackImp> *openCallbackSpec = new CComObjectNoLock<COpenCallbackImp>;
	CComPtr<IArchiveOpenCallback> openCallback = openCallbackSpec;
    CComPtr<IInArchive> anArchiveHandler;
	HRESULT res = OpenArchive(lpFileName, &anArchiveHandler, anArchiverInfo, openCallback);
	if (lpMode)
		strcpy(lpMode, anArchiverInfo.Extension);
	return res;
}
